

// Point class for roguelike maze generator
// Copyright Gerry Quinn
// 25th August, 2007


#if !defined(AFX_POINT_H__66490126_B38B_4FDE_A29F_AC1E3711ECDD__INCLUDED_)
#define AFX_POINT_H__66490126_B38B_4FDE_A29F_AC1E3711ECDD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


// A helper class, used to store pairs of values
// Used where I would normally use CPoint or CSize from MFC
class Point  
{
public:
	int x;
	int y;

public:
	
	inline Point operator + ( const Point & other ) const { return Point( x + other.x, y + other.y ); }
	inline Point operator - ( const Point & other ) const { return Point( x - other.x, y - other.y ); }
	inline Point operator += ( const Point & other ) { x += other.x; y += other.y; return *this; }
	inline Point operator -= ( const Point & other ) { x -= other.x; y -= other.y; return *this; }
	inline Point operator - () const { return Point( -x, -y ); }

	inline Point( int xVal, int yVal ) { x = xVal; y = yVal; }
	inline Point() {};
	inline ~Point() {};

};

#endif // !defined(AFX_POINT_H__66490126_B38B_4FDE_A29F_AC1E3711ECDD__INCLUDED_)
